unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComObj, ShDocVw, ComCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    dlGuardar: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    bObterContactos: TButton;
    txtContactos: TMemo;
    GroupBox1: TGroupBox;
    opNombre: TCheckBox;
    opEmail: TCheckBox;
    opTelefonoMovil: TCheckBox;
    opTelefonoTrabajo: TCheckBox;
    opEncabezado: TCheckBox;
    opPaginaWeb: TCheckBox;
    opTelefonoParticular: TCheckBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    txtNombrePerfil: TEdit;
    txtContrasena: TEdit;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtCarpetaPersonal: TComboBox;
    txtNombreContactos: TComboBox;
    bSalir: TButton;
    Button1: TButton;
    gEmail: TGroupBox;
    Label3: TLabel;
    txtCarpetaEmail: TComboBox;
    bObtenerEmail: TButton;
    Label6: TLabel;
    txtTextoBusquedaEmail: TEdit;
    lInfoProgresoEmail: TLabel;
    bpEmail2: TProgressBar;
    lInfoProgresoEmail2: TLabel;
    opBuscarAsunto: TCheckBox;
    opMostrarAsunto: TCheckBox;
    opBuscarCuerpo: TCheckBox;
    tabEmail: TPageControl;
    tabEmailEmail: TTabSheet;
    tabEmailErrores: TTabSheet;
    txtEmail: TMemo;
    bGuardarEmail: TButton;
    txtResultadoEmail: TMemo;
    lInfoEmailEncontrados: TLabel;
    lInfoEmailEncontrados2: TLabel;
    bObtenerCarpetas: TButton;
    bpContactos: TProgressBar;
    lInfoContactos: TLabel;
    LWEB: TLabel;

    procedure nuevoContacto;
    procedure listaContactos;
    procedure obtenerEmail (carpetasEmail : OleVariant; nombreCarpeta : string);
    procedure obtenerCarpetas ();        

    procedure bObterContactosClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bObtenerEmailClick(Sender: TObject);
    procedure bGuardarEmailClick(Sender: TObject);
    procedure bObtenerCarpetasClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  linea : string;
  carpetasOutlook : TStringList;
  emails : TStringList;
  encontrados : integer;
  tamanoEmail : double;
const
  //Carpetas de Outlook
  carEliminados = $00000003; //Elementos eliminados
  carBandejaSalida = $00000004; //Bandeja de salida
  carEnviados = $00000005; // Enviados
  carBandejaEntrada = $00000006; //Bandeja de entrada
  carCalendario = $00000009; //Calendario
  carContactos = $0000000A; //Contactos
  carDiario = $0000000B; //Diario
  carNotas = $0000000C; //Notas
  carTareas = $0000000D; //Tareas
  carBorrador = $00000010; //Borrador

implementation

{$R *.dfm}


procedure TformMenuPrincipal.nuevoContacto;
var
  MsOutlook, MapiName, MyContact : variant;
begin
  try
    MsOutlook := CreateOleObject('Outlook.Application');
  except
    ShowMessage('Could not start Microsoft Outlook.');
    Exit;
  end;
  try
    MapiName := MsOutlook.GetNameSpace('MAPI');
    If MsOutlook.name = 'Outlook' Then
    begin
      MapiName.Logon('profile','password');
      Mycontact := MapiName.folders('Personal Folders').folders('Contacts').items.Add;
      Mycontact.FullName := 'My test';
      Mycontact.Fileas := 'My test';
      Mycontact.email1address := 'test@test.test';
      Mycontact.save;
    end
    else
      showmessage('Outlook has not returned the correct name. Process terminated');
  finally
    MsOutlook := null;
  end;
end;

procedure nuevaColumna (cadena : string);
begin
  if linea <> '' then
    linea :=  linea + '; "' + cadena + '"'
  else
    linea := '"' + cadena + '"';
end;

procedure TformMenuPrincipal.listaContactos;
var
  MsOutlook, MapiName, MisContactos : variant;
  y : integer;
  contactosTemp : TStringList;
begin
  lInfoContactos.Caption := 'Conectado a Outlook...';
  lInfoContactos.Refresh;
  txtContactos.Lines.Clear;
  try
    MsOutlook := CreateOleObject('Outlook.Application');
  except
    on err : exception do
    begin
      lInfoContactos.Caption := '';
      lInfoContactos.Refresh;
      MessageDlg ('No se ha podido acceder a Outlook. Se ha producido el siguiente error: ' +
          chr(13) + chr(13) + err.Message, mtError, [mbok], 0);
      Exit;
    end;
  end;
  try
    MapiName := MsOutlook.GetNameSpace('MAPI');
    If MsOutlook.name = 'Outlook' Then
    begin
  //    MapiName.Logoff;
  //    MapiName.Logon(txtNombrePerfil.Text, txtContrasena.text);
      contactosTemp := TStringList.Create;
      if opEncabezado.Checked then
      begin
        if opNombre.Checked then
          nuevaColumna('Nombre');
        if opEmail.Checked then
          nuevaColumna('Email');
        if opTelefonoMovil.Checked then
          nuevaColumna('Telfono mvil');
        if opTelefonoTrabajo.Checked then
          nuevaColumna('Telfono trabajo');
        if opTelefonoParticular.Checked then
          nuevaColumna('Telfono particular');
        if opPaginaWeb.Checked then
          nuevaColumna('Pgina web');
        txtContactos.Lines.Add(linea)
      end;
      bpContactos.Visible := true;      
      bpContactos.Min := 0;
      for y := 1 to MapiName.folders(txtCarpetaPersonal.text).folders(txtNombreContactos.text).items.count do
      begin
        bpContactos.Position := y;
        bpContactos.Refresh;
        lInfoContactos.Caption := 'Obteniendo contacto ' + inttostr(y) +
            ' de ' + inttostr(bpContactos.Max);
        lInfoContactos.Refresh;
        MisContactos := MapiName.folders(txtCarpetaPersonal.Text).folders(txtNombreContactos.Text).items(y);
        try
          linea := '';
          if opNombre.Checked then
            nuevaColumna (MisContactos.FullName);
          if opEmail.Checked then
            nuevaColumna (MisContactos.Email1Address);
          if opTelefonoMovil.Checked then
            nuevaColumna (MisContactos.MobileTelephoneNumber);
          if opTelefonoTrabajo.Checked then
            nuevaColumna (MisContactos.BusinessTelephoneNumber);
          if opTelefonoParticular.Checked then
            nuevaColumna (MisContactos.HomeTelephoneNumber);
          if opPaginaWeb.Checked then
            nuevaColumna (MisContactos.PersonalHomePage);
          if linea <> '' then
            contactosTemp.Add(linea);
        except
        end;
      end;
      txtContactos.Lines.AddStrings(contactosTemp);
    end
    else
      MessageDlg ('No se ha podido acceder a Outlook.', mtWarning, [mbok], 0);
  except
    on err : exception do
    begin
      lInfoContactos.Caption := '';
      bpContactos.Visible := false;
      MessageDlg ('No se ha podido acceder a Outlook. Se ha producido el siguiente error: ' +
          chr(13) + chr(13) + err.Message, mtError, [mbok], 0);
      MsOutlook := null;
    end;
  end;
  MsOutlook := null;
end;

procedure TformMenuPrincipal.bObterContactosClick(Sender: TObject);
begin
  listaContactos;
end;

//propiedades para los contactos
  {Birthday
  Business2TelephoneNumber
  BusinessAddress
  BusinessAddressCity
  BusinessAddressCountry
  BusinessAddressPostalCode
  BusinessAddressPostOfficeBox
  BusinessAddressState
  BusinessAddressStreet
  BusinessFaxNumber
  BusinessHomePage
  BusinessTelephoneNumber
  CompanyAndFullName
  CompanyMainTelephoneNumber
  CompanyName
  ComputerNetworkName
  Department
  Email1Address
  Email1AddressType
  Email1DisplayName
  Email2Address
  Email2AddressType
  Email2DisplayName
  Email3Address
  Email3AddressType
  Email3DisplayName
  FirstName
  FTPSite
  FullName
  FullNameAndCompany
  GovernmentIDNumber
  Hobby
  Home2TelephoneNumber
  HomeAddress
  HomeAddressCity
  HomeAddressCountry
  HomeAddressPostalCode
  HomeAddressPostOfficeBox
  HomeAddressState
  HomeAddressStree
  HomeFaxNumber
  HomeTelephoneNumber
  Initials
  ISDNNumber
  JobTitle
  Language
  LastName
  LastNameAndFirstName
  MailingAddress
  MailingAddressCity
  MailingAddressCountry
  MailingAddressPostalCode
  MailingAddressPostOfficeBox
  MailingAddressState
  MailingAddressStreet
  MiddleName
  NickName
  OfficeLocation
  OrganizationalIDNumber
  PersonalHomePage
  PrimaryTelephoneNumber
  Profession
  Suffix
  Title
  WebPage
  EntryID
  MobileTelephoneNumber}


procedure TformMenuPrincipal.Button1Click(Sender: TObject);
begin
  dlGuardar.Title := 'Guardar Contactos...';
  dlGuardar.FileName := 'Contactos';
  if dlGuardar.Execute then
    txtContactos.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformMenuPrincipal.bSalirClick(Sender: TObject);
begin
 Close;
end;

procedure cargarCarpeta(Folder: OleVariant);
var
  i : Integer;
begin
  for i := 1 to Folder.Count do
  begin
    carpetasOutlook.Add(Folder.Item[i].Name);
    cargarCarpeta(Folder.Item[i].Folders);
  end;
end;


procedure TformMenuPrincipal.obtenerCarpetas ();
var
  outlook : OLEVariant;
  NameSpace : variant;
begin
  try
    //mostramos en el desplegable las carpetas de outlook
    outlook := CreateOleObject('Outlook.Application');
    NameSpace := outlook.GetNameSpace('MAPI');
    //NameSpace.Logon(txtNombrePerfil.Text, txtContrasena.text);
    carpetasOutlook := TStringList.Create;
    cargarCarpeta(NameSpace.Folders);
    txtCarpetaPersonal.Clear;
    txtNombreContactos.Clear;
    txtCarpetaEmail.Clear;
    txtNombreContactos.Clear;
    txtCarpetaPersonal.Items.AddStrings(carpetasOutlook);
    txtNombreContactos.Items.AddStrings(carpetasOutlook);
    txtCarpetaEmail.Items.AddStrings(carpetasOutlook);
    txtCarpetaEmail.Items.Add('Todas las carpetas');
    //asignamos la carpeta de "contactos" por defecto
    txtNombreContactos.Text :=  NameSpace.GetDefaultFolder(carContactos);
    txtCarpetaPersonal.Text := 'Carpetas personales';
  except
    on err : exception do
    begin
      outlook := UnAssigned;
      MessageDlg('No se ha podido acceder a Outlook con el perfil por defecto, compruebe los datos del perfil: ' +
          chr(13) + chr(13) + err.message, mtInformation, [mbok], 0);
    end;
  end;
end;


procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  ObtenerCarpetas;
end;

procedure TformMenuPrincipal.obtenerEmail (carpetasEmail : OleVariant; nombreCarpeta : string);
var
  i, j : Integer;
  MailItem : OleVariant;
  emisorEmail, asuntoEmail, textoEmail : string;
  mostrarEmail : boolean;
  tamanoActual : double;
begin
  for i := 1 to carpetasEmail.Count do
  begin
    lInfoProgresoEmail.Caption := 'Obteniendo carpeta ' + carpetasEmail.Item[i].Name;
    lInfoProgresoEmail.refresh;
    if (carpetasEmail.Item[i].Name = nombreCarpeta) or
        (nombreCarpeta = 'Todas las carpetas')  then
    begin
      if carpetasEmail.Item[i].Items.count > 0 then
      begin
        bpEmail2.Min := 1;
        bpEmail2.Max := carpetasEmail.Item[i].Items.count;
        for j := 1 to carpetasEmail.Item[i].Items.count do
        begin
          bpEmail2.Position := j;
          lInfoProgresoEmail2.Caption := 'Buscando en email ' + inttostr(j) +
             ' de ' + inttostr(carpetasEmail.Item[i].Items.count);
          lInfoProgresoEmail2.refresh;
          Application.ProcessMessages;
          try
            mailitem := carpetasEmail.Item[i].Items[j];
            asuntoEmail := Mailitem.Subject;
            emisorEmail := Mailitem.SenderName;
            textoEmail := mailitem.Body;
            tamanoActual := MailItem.Size;
            mostrarEmail := false;
            if txtTextoBusquedaEmail.Text = '' then
              mostrarEmail := true
            else
            begin
              if opBuscarAsunto.Checked then
                mostrarEmail := Pos (txtTextoBusquedaEmail.Text, asuntoEmail) > 0;
              if not mostrarEmail and opBuscarCuerpo.Checked then
                 mostrarEmail := Pos (txtTextoBusquedaEmail.Text, textoEmail) > 0
            end;
            if mostrarEmail then
            begin
              tamanoEmail := tamanoEmail + tamanoActual;
              encontrados := encontrados + 1;
              lInfoEmailEncontrados.Caption := 'Emails encontrados: ' + IntToStr(encontrados);
              lInfoEmailEncontrados.Refresh;
              if opMostrarAsunto.Checked then
              begin
                emails.Add('Nombre emisor: ' + emisorEmail);
                emails.Add('Asunto: ' + asuntoEmail);
              end
              else
              begin
                emails.Add('Emisor: ' + emisorEmail);
                emails.Add('Asunto: ' + asuntoEmail);
                emails.Text := emails.Text + textoEmail;
              end;
              emails.Add('');
              emails.Add('');
              emails.Add ('****************************************');
              emails.Add('');
              emails.Add('');
            end;
          except
            on err : exception do
            begin
              txtResultadoEmail.Lines.Add('Error al obtener email ' +
                 inttostr(j) + ' en carpeta: ' + carpetasEmail.Item[i].Name)
            end;
          end;
        end;
      end;
    end;
    obtenerEmail (carpetasEmail.Item[i].Folders, nombreCarpeta);
  end;
end;

procedure TformMenuPrincipal.bObtenerEmailClick(Sender: TObject);
var
  outlook, NameSpace : OLEVariant;
begin
 try
   tabEmail.Visible := false;
   txtResultadoEmail.Lines.Clear;
   txtEmail.Lines.Clear;
   lInfoEmailEncontrados.Caption := '';
   lInfoEmailEncontrados2.Caption := '';
   encontrados := 0;
   txtEmail.Visible := false;
   gEmail.Height := 214;
   lInfoProgresoEmail.Caption := 'Obteniendo datos de Emails';
   lInfoProgresoEmail.Visible := true;
   outlook := CreateOleObject('Outlook.Application');
   NameSpace := outlook.GetNameSpace('MAPI');
   emails := TStringList.Create;
   obtenerEmail (NameSpace.Folders, txtCarpetaEmail.Text);
   txtEmail.Lines.AddStrings(emails);
   if encontrados > 0 then
   begin
     txtResultadoEmail.Lines.Add('');
     txtResultadoEmail.Lines.Add('');
     txtResultadoEmail.Lines.Add('Emails encontrados: ' + inttostr(encontrados));
     if tamanoEmail < 1048576 then
       txtResultadoEmail.Lines.Add('Tamao ocupado: ' + FormatFloat('#,###" KB"', tamanoEmail / 1024))
     else
       txtResultadoEmail.Lines.Add('Tamao ocupado: ' + FormatFloat('#,###" MB"', tamanoEmail / 1048576))
   end;
  except
    on err : exception do
    begin
      txtEmail.Visible := true;
      tabEmail.Visible := true;      
      gEmail.Height := 104;
      outlook := UnAssigned;
      txtResultadoEmail.Lines.Add ('Error al obtener los emails: ' +
          err.Message);
    end;
  end;
  tabEmail.Visible := true;
  outlook := UnAssigned;
  txtEmail.Visible := true;
  gEmail.Height := 104;
  if encontrados > 0 then
    lInfoEmailEncontrados2.Caption := 'Emails encontrados: ' + inttostr(encontrados)
  else
    lInfoEmailEncontrados2.Caption := 'No se han encontrado coincidencias';
end;

procedure TformMenuPrincipal.bGuardarEmailClick(Sender: TObject);
begin
  dlGuardar.Title := 'Guardar Email...';
  dlGuardar.FileName := 'Emails';
  if dlGuardar.Execute then
    txtEmail.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformMenuPrincipal.bObtenerCarpetasClick(Sender: TObject);
begin
  obtenerCarpetas ();
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
